#include <iostream>
#include <cmath>
#include <chrono>
#include "src/rkv78_serie.h"
#include "src/differential_equation.cpp"
#include "src/utils.h"

using namespace std;

// Variables a canviar per a l'us de la funció buscar_punt_fix:
double at;
int n;
double ah;
double tol;
double atf;
double aer;
int sc;
int vap_a_usar;
void (*dif)(double, double *, int, double *);
void (*dif_final)(double, double *, int, double *);
void (*dif_serie)(double, Serie **, int, Serie **);

// Grau dels polinomis per defecte
int DEGREE = 0;

/**
 * Funció main. Des d'aquí s'han de cridar les funcions de la llibreria utils.
 * @return
 */
int main() {

    cout.precision(16);
    // Variables per a cridar buscar_punt_fix i buscar_vap_vep (explicades en detall a la secció guia d'us del programa)

    // Temps inicial
    at = 0;

    // Dimensio
    n = 6;

    // Condicio inicial
    double x[6];
    x[0] = -M_PI;
    x[1] = 0;

    // Pas inicial
    ah = 0.001;

    // Pas variable(1)/fix(0)
    sc = 1;

    // Tolerancia
    tol = 1.e-15;

    // Temps final d'integracio
    double omega = sqrt(20);
    atf = 2*M_PI/omega;

    // Sortir(0)/seguir(1) si l'error supera la tolerancia
    aer = 1;

    // Equacio diferencial
    dif = &Disturbed_Pendulum_Matrix::edo;

    // ----------------------------------------------------------------------

    // Crida a la funcio de buscar punt fix

    utils::UtilFunctions::buscar_punt_fix(&at, x, n, &ah, sc, 1.e-15, &atf, &aer, dif);

    // ----------------------------------------------------------------------

    // Variables per a la crida de la funcio de buscar vaps i veps
    at = 0;
    ah = 0.01;
    double vap1;
    double vap2;
    double vep1[2];
    double vep2[2];

    // ----------------------------------------------------------------------

    // Crida a la funcio de buscar vaps i veps
    utils::UtilFunctions::buscar_vap_vep(&at, x, n, &ah, sc, tol, &atf, &aer, dif, &vap1, &vap2, vep1, vep2);

    // ----------------------------------------------------------------------

    // Variables per a cridar buscar_varietat
    at = 0;
    ah = 0.01;

    // Grau dels polinomis
    int deg = 6;

    // Vap a usar, segons si volem varietat estable(0)/inestable(1)
    vap_a_usar = 0;

    // Equacio diferencial amb series
    dif_serie = &Disturbed_Pendulum_Serie::edo;

    // ----------------------------------------------------------------------

    // Crida a la funcio buscar_varietat

    utils::UtilFunctions::buscar_varietat(&at, x, 2, &ah, sc, tol, &atf, &aer, dif, deg, vap_a_usar, dif_serie);

}