//
// Created by Martí Rubio Estrada on 19/11/2019.
//

#ifndef SERIE_H
#define SERIE_H

extern int DEGREE;

/**
 * Classe per a operar amb sèries.
 * Aquesta classe permet crear polinomis amb un grau determinat i operar amb ells
 */
class Serie{

public:
    Serie(int degree);
    Serie();
    Serie(double* in_coeff, int degree);

    ~Serie();

    int getDegree() const;
    double* getCoeff() const;
    void setCoeff(double value, int position);
    void addCoeff(double value, int position);
    double getCoeff(int position) const;

    Serie& operator=(const Serie serie);

    Serie& operator=(const Serie* serie);

    Serie operator+(const Serie serie);

    Serie operator+(const Serie* serie);

    Serie operator-(const Serie serie);

    Serie operator*(const Serie serie);

    Serie operator/(const Serie serie);

    Serie operator+(double value);

    Serie operator-(double value);

    Serie operator-();

    Serie operator*(double value);

    Serie operator/(double value);

    Serie operator+=(const Serie serie);

    Serie operator-=(const Serie serie);

    Serie operator*=(const Serie serie);

    Serie operator/=(const Serie serie);

    Serie operator+=(double value);

    Serie operator-=(double value);

    Serie operator*=(double value);

    Serie operator/=(double value);

    bool operator==(Serie serie);

    bool operator!=(Serie serie);

    bool operator==(double value);

    bool operator!=(double value);

    Serie derivate(); //Fet

    Serie sqrt();

    Serie log();

    Serie exp();

    Serie pow(double a);

    Serie sin();

    Serie cos();

    double calculate(double s);

    void empty_coef(){
        delete this->coeff;
    };

private:
    /**
     * Variable que guarda els coeficients del polinomi
     */
    double* coeff;

    /**
     * Variable que guarda el grau del polinomi
     */
    int degree;
};

#endif //SERIE_H
