//
// Created by Martí Rubio Estrada on 24/11/2019.
//

#ifndef RKV78_SERIE_H
#define RKV78_SERIE_H

#include "Serie.h"

/**
 * Package que conté les funcions necessàries per a realitzar el mètode
 * Runge-Kutta 7(8) treballant amb objectes sèrie
 */
namespace rkv78_serie{

    class rkv78_serie{

    public:
        static int rkv78_main(double *at, Serie **x, int n, double *ah, int sc, double tol,
                              double *atf, double *aer, void (*edo)(double, Serie **, int, Serie **));

    private:
        static double error_rk(int n, Serie **k);
        static double step_rk(Serie **x, int n, Serie **k);
        static void compute_ks(double t, Serie **x, int n, double h,
                                      Serie **k, void (*ode)(double,Serie**,int,Serie**));
    };
}

#endif //RKV78_SERIE_H
