//
// Created by Martí Rubio Estrada on 06/01/2020.
//

#ifndef UTILS_H
#define UTILS_H

#include "Serie.h"

/**
 * Paquet que conté funcions útils predeterminades.
 */
namespace utils{

    class UtilFunctions{

        public:
            static void buscar_punt_fix(double *at, double *x, int n, double *ah, int sc, double tol,
                       double *atf, double *aer, void (*dif)(double,double*,int,double*));

        static void evaluate_positive_time(double *at, double *x, int n, double *ah, int sc, double tol,
                                                   double *atf, double *aer, void (*dif)(double,double*,int,double*));
        static void evaluate_negative_time(double *at, double *x, int n, double *ah, int sc, double tol,
                                                   double *atf, double *aer, void (*dif)(double,double*,int,double*));

            static void buscar_vap_vep(double *at, double *x, int n, double *ah, int sc, double tol,
                                 double *atf, double *aer, void (*dif)(double,double*,int,double*),
                                 double *vap1, double *vap2, double vep1[],double vep2[]);
            static void buscar_vap_vep(double *at, double *x, int n, double *ah, int sc, double tol,
                                 double *atf, double *aer, void (*dif)(double,double*,int,double*));

            static void buscar_varietat(double *at, double *x, int n, double *ah, int sc, double tol,
                                 double *atf, double *aer, void (*dif)(double, double *, int, double *),
                                 int deg, int vap_a_usar, void (*dif_serie)(double,Serie**,int,Serie**));

    };
}

#endif //UTILS_H
